def test_setup():
    # import inline in order not to cause any import issues

    from IPython.display import display
    import ipywidgets as widgets
    import pandas as pd
    import qgrid
    import plotly
    import plotly.graph_objs as go

    import bamboolib as bam
    from bamboolib.widgets import Multiselect

    print("Testing Jupyter extensions:")

    print("")
    print("ipywidgets:")
    display(widgets.Text("ipywidgets works"))
    print("")
    print("qgrid:")
    print(f"Python library version is {qgrid.__version__}")
    qgrid_df = pd.DataFrame.from_dict({"test qgrid": ["qgrid widget works"]})
    display(
        qgrid.show_grid(
            qgrid_df, grid_options={"maxVisibleRows": 2, "minVisibleRows": 2}
        )
    )

    print("")
    print("plotly:")
    print(f"Python library version is {plotly.__version__}")
    trace = go.Bar(x=["Plotly", "works"], y=[1, 2])
    layout = dict(height=350, width=500)
    display(go.FigureWidget(data=[trace], layout=layout))

    print("")
    print("bamboolib:")
    print(f"Python library version is {bam.__version__}")
    print(f"Needed version of Jupyter extension is {bam.__widgets_version__}")
    display(Multiselect(placeholder="bamboolib widget works"))

    print("")
    try:
        from jupyterlab import commands
    except ImportError:
        return
    print("JupyterLab and Labextensions:")
    commands.list_extensions()
