# NOTE: This file is NOT cythonized!

import ipywidgets as widgets

from bamboolib.edaviz.__modules__ import _column_summary, get_loading_widget, compare

from bamboolib.helper import TabViewable, execute_async_after_10ms


class ColumnSummary(TabViewable):
    def __init__(self, column="", **kwargs):
        super().__init__(**kwargs)
        self.column = column

    def render(self):
        self.set_title(f"{self.column}")

        self.set_content(
            widgets.VBox(
                [
                    get_loading_widget(),
                    widgets.HTML("<br><br><br><br><br><br><br><br><br><br><br>"),
                ]
            )
        )

        def full_render():
            df = self.df_manager.get_current_df()
            self.set_content(
                _column_summary(
                    df,
                    self.column,
                    df_manager=self.df_manager,
                    parent_tabs=self.parent_tabs,
                )
            )

        execute_async_after_10ms(full_render)


class RelateColumns(TabViewable):
    def __init__(self, x="", y="", **kwargs):
        super().__init__(**kwargs)
        self.x = x
        self.y = y

    def render(self):
        self.set_title(f"{self.x} predicts {self.y}")

        self.set_content(
            widgets.VBox(
                [
                    get_loading_widget(),
                    widgets.HTML("<br><br><br><br><br><br><br><br><br><br><br>"),
                ]
            )
        )

        def full_render():
            df = self.df_manager.get_current_df()
            self.set_content(
                compare(
                    df,
                    self.x,
                    self.y,
                    df_manager=self.df_manager,
                    parent_tabs=self.parent_tabs,
                )
            )

        execute_async_after_10ms(full_render)


class EmbeddableToTabviewable(TabViewable):
    def __init__(self, title, embeddable, **kwargs):
        super().__init__(**kwargs)
        self.title = title
        self.embeddable = embeddable

    def render(self):
        self.set_title(self.title)
        self.set_content(self.embeddable)
